package net.rmi.rjs.pk.LusCs;

import net.rmi.rjs.pk.rmiFileTransfer.FileServerImplementation;
import net.rmi.rjs.pk.rmiFileTransfer.FileTransClient;
import net.rmi.rjs.pk.rmiFileTransfer.FileTransInterface;

import java.net.InetAddress;
import java.net.UnknownHostException;
import java.net.MalformedURLException;
import java.util.Observable;
import java.util.Date;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;


/**
 * Created by IntelliJ IDEA. User: pkrepszt Date: Feb 28, 2005 Time:
 * 10:13:53 PM To change this template use File | Settings | File
 * Templates.
 */

public class CsRecord extends Observable {
    private InetAddress ipAddress ;

    private BenchMarkBean bmb ;
    private long timeOfInstance = System.currentTimeMillis();
    private boolean onTheGrid = true;
    private boolean dead = false;

    public CsRecord(){
        try {
            ipAddress = InetAddress.getLocalHost();
            System.out.println("InetAddress.getLocalHost " +  ipAddress);
        } catch (UnknownHostException e) {
            e.printStackTrace();

        }
        bmb = new BenchMarkBean();
    }

    public InetAddress getIpAddress() {
        return ipAddress;
    }


    public void setIpAddress(InetAddress ip) {
        ipAddress = ip;
        updateObservers();

    }

    public void updateObservers(){
        setChanged();
        notifyObservers();
    }
    public long getTimeOfInstantiation() {
        return timeOfInstance;
    }
    public Date getDateOfInstance(){
        return new Date(timeOfInstance);
    }
    public String toString() {
        StringBuffer sb = new StringBuffer();
        sb.append("\nCS Ip address: "+ getIpAddress().getHostAddress());
        sb.append("\nOn the Grid:  "+isOnTheGrid());
        sb.append("\nFlops:  "+ bmb);
        sb.append("\ndate entered:  "+this.getDateOfInstance());
        sb.append("\nRmiUrl:     "+getRmiUrl());
        sb.append("\n-------------------------------" +
            "-------------------------------------------" +
            "--------------------------------------------\n");
        return sb.toString();
    }

    public BenchMarkBean getBmb() {
        return bmb;
    }

    public void setBmb(BenchMarkBean bmb) {
        if (this.bmb.getMflops() == bmb.getMflops()) return;
        this.bmb = bmb;
        updateObservers();
    }

    public boolean isOnTheGrid() {
        return onTheGrid;
    }

    public void setOnTheGrid(boolean onTheGrid) {
        if (this.onTheGrid == onTheGrid) return;
        this.onTheGrid = onTheGrid;
        String rmiUrl = getRmiUrl();
        try {
            FileTransInterface fti = FileTransClient.lookupServer(rmiUrl);
            fti.setIsOnTheGrid(onTheGrid);
        } catch (NotBoundException e) {
            e.printStackTrace();
        } catch (MalformedURLException e) {
            e.printStackTrace();
        } catch (RemoteException e) {
            e.printStackTrace();
        }

        updateObservers();
    }


    public String getRmiUrl(){
        return   "rmi:/" +
               getIpAddress() +
               "/" +
               FileServerImplementation.REMOTE_NAME;
    }

    public void updateBenchMark() {
        bmb = getNewBenchMarkBean();
        updateObservers();
    }

    private BenchMarkBean getNewBenchMarkBean() {
        String rmiUrl = getRmiUrl();
        try {
            FileTransInterface fti = FileTransClient.lookupServer(rmiUrl);
            return fti.getBenchMarkBean();
        } catch (NotBoundException e) {
            e.printStackTrace();
        } catch (MalformedURLException e) {
            e.printStackTrace();
        } catch (RemoteException e) {
            e.printStackTrace();
        }
        return bmb;
    }
    public void kill(){
        dead = true;
        updateObservers();
    }
    public boolean isDead() {
        return dead;
    }
}
